package sketch;


#use strict;
#use warnings;
#use Color::Rgb;

$PI = 4*atan2(1,1);

sub new{
my $self =shift  @_;
($_pixels,$_border ) = @_;

$_xmin=100000;
$_ymin=100000;
$_xmax=-100000;
$_ymax=-100000;
$_ref = 82;

$current_default = 1;   #defaults to moveto using Line style

$_Dx=0; #start position of noun in world coordinates
$_Dy=0; #start position of noun in world coordinates
$_M[0] = 1;
$_Mx[0] = 1;
$_My[0] = 1;

$_Wy[0] =0; # world coordinates of the start of the scaled window
$_Wx[0] =0;


$_angle=0;
$_sinT=0;
$_cosT=1 ;

%drawing_styles=(#  would be default colors and linewidths at startup
L_c=>[0x00ff00],  #black for the main line color
l_c=>[0x0000ff],  # grey for the secondary color
F_c=>[0xffff00], #black for the main line color
f_c=>[0x0000ff],  #white for the background color
L_w=>[3],  # main color width
l_w=>[1]  # secondary color width
);
return  $self;
};  

sub rotate {
$_angle = $_angle + $_[1];
$_sinT = sin($_angle*$PI / 180);
$_cosT = cos($_angle*$PI/180);
return ($_angle, $_sinT, $_cosT);
}

sub space_M_agnify{
my @input = @_;
if(@input == 2){
($self, $xxx) = @input;
$yyy = $xxx;
}
if(@input == 3){
($self, $xxx,$yyy) = @input;
}
unshift @_Mx , $xxx*$_Mx[0];
unshift @_My , $yyy*$_My[0];

unshift @_M , $xxx*$_M[0];
unshift @_Wx, 0; #  noun displacement of the start of the scaled window
unshift @_Wy, 0;  # values are meaningless , they will be updated when the noun starts
# @_M will store magnifications "of" nouns
# @_m will store magnifications within nouns
# @_mc will store magnifications within captions
}

sub space_m_agnify{  #destroy the last magnification entry
shift @_Mx;
shift @_My;
shift @_M;
shift @_Wx;
shift @_Wy;
}

sub space_U_pdate{
push @_y, 0;
push @_x, 0;
push @_flag, 25;
}

sub moveTo{
($self, $xx,$yy)=@_;
($xx, $yy) = ($_Mx[0]*$xx,$_My[0]*$yy); 
($xx, $yy)=($_cosT*$xx-$_sinT*$yy, $_sinT*$xx+$_cosT*$yy);
$xx = $xx+$_Dx;
$yy = $yy+$_Dy;

if($xx < $_xmin ){$_xmin = $xx}
if($xx > $_xmax ){$_xmax = $xx}
if($yy < $_ymin ){$_ymin = $yy}
if($yy > $_ymax ){$_ymax = $yy}
push @_x, $xx;
push @_y, $yy;
push @_flag, 0;

}


sub lineTo{
($self,$xx,$yy)=@_;
($xx, $yy) = ($_Mx[0]*$xx,$_My[0]*$yy); 
($xx, $yy)=($_cosT*$xx-$_sinT*$yy, $_sinT*$xx+$_cosT*$yy);
$xx = $xx+$_Dx;
$yy = $yy+$_Dy;

if($xx < $_xmin ){$_xmin = $xx}
if($xx > $_xmax ){$_xmax = $xx}
if($yy < $_ymin ){$_ymin = $yy}
if($yy > $_ymax ){$_ymax = $yy}
push @_x, $xx;
push @_y, $yy;
push @_flag, 2;

}

sub LineTo{
($self,$xx,$yy)=@_;
($xx, $yy) = ($_Mx[0]*$xx,$_My[0]*$yy); 
($xx, $yy)=($_cosT*$xx-$_sinT*$yy, $_sinT*$xx+$_cosT*$yy);
$xx = $xx+$_Dx;
$yy = $yy+$_Dy;

if($xx < $_xmin ){$_xmin = $xx}
if($xx > $_xmax ){$_xmax = $xx}
if($yy < $_ymin ){$_ymin = $yy}
if($yy > $_ymax ){$_ymax = $yy}
push @_x, $xx;
push @_y, $yy;
push @_flag, 1;

}

sub fill{
($self,$xx,$yy)=@_;
($xx, $yy) = ($_Mx[0]*$xx,$_My[0]*$yy); 
($xx, $yy)=($_cosT*$xx-$_sinT*$yy, $_sinT*$xx+$_cosT*$yy);
$xx = $xx+$_Dx;
$yy = $yy+$_Dy;
push @_x, $xx;
push @_y, $yy;
push @_flag, 4;
}

sub Fill{
($self,$xx,$yy)=@_;
($xx, $yy) = ($_Mx[0]*$xx,$_My[0]*$yy); 
($xx, $yy)=($_cosT*$xx-$_sinT*$yy, $_sinT*$xx+$_cosT*$yy);
$xx = $xx+$_Dx;
$yy = $yy+$_Dy;
push @_x, $xx;
push @_y, $yy;
push @_flag, 3;
}

sub space_C_aption{
($self,$xx,$yy)=@_;
($xx, $yy) = ($_Mx[0]*$xx,$_My[0]*$yy); 
($xx, $yy)=($_cosT*$xx-$_sinT*$yy, $_sinT*$xx+$_cosT*$yy);
$xx = $xx+$_Dx;
$yy = $yy+$_Dy;

push @_x_caption, $xx;
push @_y_caption, $yy ;
push @_angle_caption, $_angle ;
}


sub travelTo{  # defines the start of the next thing
($self,$xx,$yy)=@_;
($xx, $yy) = ($_Mx[0]*$xx,$_My[0]*$yy); 
($xx, $yy)=($_cosT*$xx-$_sinT*$yy, $_sinT*$xx+$_cosT*$yy);
$_Dx = $xx+$_Dx;
$_Dy = $yy+$_Dy;
}

sub figure{
#d - body coordinates
#D - start of body in world coordinates
#Dd - world coordinates combined with body coordinates

my $_h =$_[1];

@_m = ();
unshift @_m, 1;  #initializing the internal magnifications
$_wx[0] = 0;  # these are the noun (body) displacements (from "start") 
$_wy[0] = 0;  #  #raw displacement of sub-windows - will change

## reading scaling factors for within noun
($_pair,$_h) = (substr ($_h ,0,2),substr( $_h, 2, length($_h)-2)); #reading the scaling factors
$_scaley =  ord(chop($_pair)) - $_ref;
$_scalex =  ord($_pair) - $_ref;

$_scaley =  $_scaley*$_My[0];
$_scalex = $_scalex*$_Mx[0];

## reading "start" position in noun coordinates
($_pair,$_h) = (substr ($_h ,0,2),substr( $_h, 2, length($_h)-2)); #body cordinates for start
$_ybody_start = $_scaley*( ord(chop($_pair)) - $_ref);
$_xbody_start =  $_scalex*(ord($_pair) - $_ref);


## reading "end" position in noun coordinates
($_pair,$_h) = (substr ($_h ,0,2),substr( $_h, 2, length($_h)-2)); #body cordinates for end
($_ybody, $_xbody) = ( (ord(chop($_pair)) - $_ref)*$_scaley,(ord($_pair) - $_ref)*$_scalex);

## calculating displacement caused by noun in world/noun coordinates
($delta_Dx, $delta_Dy) = ($_xbody-$_xbody_start,$_ybody-$_ybody_start);
($delta_Dx, $delta_Dy) =($_cosT*$delta_Dx-$_sinT*$delta_Dy, $_sinT*$delta_Dx+$_cosT*$delta_Dy); 
#($delta_Dx, $delta_Dy) =($_M[0]*$delta_Dx, $_M[0]*$delta_Dy) ;



$_lineto = 0;
while (length($_h) >0){
($_pair,$_h) = (substr ($_h ,0,2),substr( $_h, 2, length($_h)-2));

if ($_pair eq " R"){$_lineto = 0;
next;}
if ($_pair eq " C"){$_lineto = 5;  #next pair indicates where the caption is to start 
next;}
if ($_pair eq " N"){$_lineto = 6;  #next pair indicates where the Node is set
next;}
if ($_pair eq " L"){$current_default=1;  #1 is for the main line style
next;}
if ($_pair eq " l"){$current_default=2;  #2 is for the secondary line style
next;}
if ($_pair eq " F"){$_lineto = 3;  #fill
next;}
if ($_pair eq " f"){$_lineto = 4;  #fill
next;}

if ($_pair eq " M"){
($_pair,$_h) = (substr ($_h ,0,2),substr( $_h, 2, length($_h)-2));#reading and destroying the next pair
my $den =  ord(chop($_pair)) - $_ref;
my $num =  ord($_pair) - $_ref;

($_pair) = (substr ($_h ,0,2));#borrowing the next pair
($_dy, $_dx) = ( (ord(chop($_pair)) - $_ref)*$_scaley,(ord($_pair) - $_ref)*$_scalex);
($_dy, $_dx) =($_dy-$_ybody_start, $_dx-$_xbody_start) ;#undeformed displacements from "start"
($_dx, $_dy) = ($_m[0]*($_dx-$_wx[0]),$_m[0]*($_dy-$_wy[0]));  #deforming for magnifications
($_dx, $_dy) = ($_wx[0]+$_dx,$_wy[0]+$_dy);  #from beginning of main window
# above we use previous parameters to calculate the new location of the start of the sub-window
#  start of new window########################################################################
# no rotation yet

unshift @_m, $_m[0]*$num/$den;
unshift @_wx ,  $_dx;  #new waypoint - not rotated
unshift @_wy ,  $_dy;
next
}

if ($_pair eq " m"){

shift @_m;  #
shift @_wx;
shift @_wy;
next;}

if ($_pair eq " U"){$_lineto = 25;  #updating the styles - there must be an entry in the queue
push @_y, 0;
push @_x, 0;
push @_flag, $_lineto;
next;}


#Proceeding to process the coordinate points-no rotation but scaling
($_dy, $_dx) = ( (ord(chop($_pair)) - $_ref)*$_scaley,(ord($_pair) - $_ref)*$_scalex);
($_dx, $_dy) = ($_dx-$_xbody_start,$_dy-$_ybody_start);
# this is the displacement in the original vectorization


# applying magnification distortions to localized regions of noun
($_dx, $_dy) = ($_wx[0]+$_m[0]*($_dx-$_wx[0]),$_wy[0]+$_m[0]*($_dy-$_wy[0])); 

#($_dx, $_dy) = ($_M[0]*$_dx,$_M[0]*$_dy); # this magnifies the whole noun
#from beginning of main window of noun (axis of rotation)
# includes the local magnification factor

($_dx, $_dy)=($_cosT*$_dx-$_sinT*$_dy, $_sinT*$_dx+$_cosT*$_dy);  #this rotates the entire noun



($_x, $_y) = ($_Dx +$_dx, $_Dy+$_dy );    #this translates the whole noun to its appropriate location


if($_x < $_xmin ){$_xmin = $_x}
if($_x > $_xmax ){$_xmax = $_x}
if($_y < $_ymin ){$_ymin = $_y}
if($_y > $_ymax ){$_ymax = $_y}

if($_lineto ==5){  #stores start position of caption in  a caption stack
# this will be used in a future call to the caption method
push @_x_caption, $_x;
push @_y_caption, $_y ;
push @_angle_caption, $_angle ;
$_lineto = $current_default ;
next;
}
if($_lineto ==6){  #stores information for the node
# this will be used in a future call to the pull_node method
push @_x_stack, $_x ;
push @_y_stack, $_y ;
push @_angle_stack, $_angle ;
$_lineto = $current_default ;
next;
}

push @_y, $_y;
push @_x, $_x;
push @_flag, $_lineto;
$_lineto = $current_default ;}

($_Dx, $_Dy) = ($_Dx+$delta_Dx, $_Dy+$delta_Dy );# world coordinates for start of next noun

return;

};




sub space_N_ode{ 
my @input = @_;
if(@input == 3){
($self,$xx,$yy)=@_;
($xx, $yy) = ($_Mx[0]*$xx,$_My[0]*$yy); 
($xx, $yy)=($_cosT*$xx-$_sinT*$yy, $_sinT*$xx+$_cosT*$yy);
$_Dx = $xx+$_Dx;
$_Dy = $yy+$_Dy;
}
push @_x_stack, $_Dx ;
push @_y_stack, $_Dy ;
push @_angle_stack, $_angle ;
};

sub pull_node{   #sets x,y and angle to beginning of Node; no within-noun version exists
# include caption stuff ??
push @_resumex ,$_Dx;
push @_resumey , $_Dy;
push @_resume_angle , $_angle;
@_M_resume = @_M;
@_Mx_resume = @_Mx;
@_My_resume = @_My;
@_Wx_resume =@_Wx;
@_Wy_resume = @_Wy;
$_Dx =pop @_x_stack;
$_Dy =pop @_y_stack;
$_angle = pop  @_angle_stack;
$_sinT = sin($_angle*$PI / 180);
$_cosT = cos($_angle*$PI/180);
};
sub resume{
$_Dx =pop @_resumex;
$_Dy =pop @_resumey;
$_angle = pop  @_resume_angle;
@_M = @_M_resume  ;
@_Mx = @_Mx_resume  ;
@_My = @_My_resume  ;
@_Wx = @_Wx_resume ;
@_Wy = @_Wy_resume ;
}  # this escapes from inside the node to business-as-usual
# space_n_node escapes from node


sub load_caption_vocabulary{
shift;
%vocab = @_;
return;
}


sub caption{

my @input = @_;

if (@input ==4){($self,$string,$relative_x,$relative_y)=@input;
$sinC = 0;
$cosC = 1;}

if (@input ==5){($self,$string,$relative_x,$relative_y,$caption_angle)=@input;
$sinC = sin($caption_angle*$PI / 180);
$cosC = cos($caption_angle*$PI/180);}

if (@input ==6){($self,$string,$relative_x,$relative_y,$caption_angle,$angle_factor)=@input;
$sinC = sin(($caption_angle*$PI / 180+$_angle*$angle_factor)*$PI / 180);
$cosC = cos(($caption_angle*$PI / 180+$_angle*$angle_factor)*$PI / 180);}


($scaled_offsetx, $scaled_offsety)= (0,0);

@_mc  = ();
@_wcx = ();
@_wcy = ();

unshift @_mc, 1;
unshift @_wcx ,  0;
unshift @_wcy ,  0;
($offsetx,$offsety) = (0,0);

$_delta_wcx = 0;
$_delta_wcy = 0;

$string = reverse($string);

$#xcaption = -1;
$#ycaption = -1;
$#flag = -1;
$_xmin_c=100000;
$_ymin_c=100000;
$_xmax_c= -100000;
$_ymax_c= -100000;

while(length($string)>0){
$character = chop($string);
if ($character eq "."){$character = "decimal"};
$hhh=$vocab{$character};
($_pair,$hhh) = (substr ($hhh ,0,2),substr( $hhh, 2, length($hhh)-2)); #reading the scaling factors
$scaley = ord(chop($_pair)) - $_ref;
$scalex =ord($_pair) - $_ref;

($_pair,$hhh) = (substr ($hhh ,0,2),substr( $hhh, 2, length($hhh)-2)); #body coordinates for start
my $ybody_start = $scaley*( ord(chop($_pair)) - $_ref);
my $xbody_start =  $scalex*(ord($_pair) - $_ref);

($_pair,$hhh) = (substr ($hhh ,0,2),substr( $hhh, 2, length($hhh)-2)); #body coordinates for end
my $ybody_finish = (ord(chop($_pair)) - $_ref)*$scaley;
my $xbody_finish  = (ord($_pair) - $_ref)*$scalex;

#$_delta_wcx = $_mc[0]*($xbody_finish-$xbody_start);
#$_delta_wcy =$_mc[0]*($ybody_finish-$ybody_start);
$_delta_wcx = ($xbody_finish-$xbody_start);
$_delta_wcy =($ybody_finish-$ybody_start);

$_lineto = 0;
while (length($hhh) >0){
($_pair,$hhh) = (substr ($hhh ,0,2),substr( $hhh, 2, length($hhh)-2));

if ($_pair eq " R"){$_lineto = 0;
next;}

if ($_pair eq " U"){
next;}
if ($_pair eq " C"){$_lineto = 5;  #next pair indicates where the caption is to start 
next;}

if ($_pair eq " N"){$_lineto = 6;  #next pair indicates where the Node is set
next;}

if ($_pair eq " L"){$current_default=1;  #1 is for the main line style
next;}
if ($_pair eq " l"){$current_default=2;  #2 is for the secondary line style
next;}

if ($_pair eq " F"){$_lineto = 3;  #fill
next;}
if ($_pair eq " f"){$_lineto = 4;  #fill
next;}


if ($_pair eq " M"){
($_pair,$hhh) = (substr ($hhh ,0,2),substr( $hhh, 2, length($hhh)-2));#reading and destroying the next pair
my $den =  ord(chop($_pair)) - $_ref;
my $num =  ord($_pair) - $_ref;

($_pair) = (substr ($hhh ,0,2));#borrowing the next pair
($_dy, $_dx) = ( (ord(chop($_pair)) - $_ref)*$scaley,(ord($_pair) - $_ref)*$scalex); #CHARACTER coordinates of next waypoint in arbitrary system
($_dy, $_dx) =($_dy-$ybody_start, $_dx-$xbody_start) ;#CHARACTER d - no deformation
($_dy, $_dx) =($offsety+$_dy, $offsetx+$_dx) ; #CAPTION version of above


($_dx, $_dy) = ($_mc[0]*($_dx-$_wcx[0]),$_mc[0]*($_dy-$_wcy[0]));  #applying deformation due to localized magnification...
($_dx, $_dy) = ($_wcx[0]+$_dx,$_wcy[0]+$_dy);  # of distance from wc
#  wx as a displacement ########################################################################

unshift @_mc, $_mc[0]*$num/$den;
unshift @_wcx ,  $_dx;
unshift @_wcy ,  $_dy;

next;
}

if ($_pair eq " m"){


#  wx as a displacement ########################################################################
($offsetx, $offsety)=($scaled_offsetx, $scaled_offsety);
shift @_mc;
shift @_wcx ,  $_dx;
shift @_wcy ,  $_dy;
next;}

# in undeformed XXX (body)coordinates we have
($ypoint, $xpoint) = ( (ord(chop($_pair)) - $_ref)*$scaley,(ord($_pair) - $_ref)*$scalex);   #CHARACTER coordinates
($raw_x, $raw_y) = ($xpoint-$xbody_start, $ypoint-$ybody_start);  # CHARACTER displacement
($raw_x, $raw_y) = ($offsetx +$raw_x , $offsety +$raw_y); # CAPTION displacement - no magnifying distortions
($world_x, $world_y)=  ($_wcx[0]+$_mc[0]*($raw_x-$_wcx[0]),$_wcy[0]+$_mc[0]*($raw_y-$_wcy[0]));   # applying magnifying distortions





($xdisplacement, $ydisplacement) =($world_x, $world_y) ;

if($world_x < $_xmin_c ){$_xmin_c = $world_x}
if($world_x > $_xmax_c ){$_xmax_c = $world_x}
if($world_y < $_ymin_c ){$_ymin_c = $world_y}
if($world_y > $_ymax_c ){$_ymax_c = $world_y}




push @xcaption, $world_x;
push @ycaption, $world_y;
push @flag, $_lineto;
$_lineto = $current_default ;
}

#offset will need to change
($offsetx, $offsety)=($offsetx+$_delta_wcx , $offsety+$_delta_wcy );
($scaled_offsetx, $scaled_offsety)=($scaled_offsetx+$_mc[0]*$_delta_wcx ,$scaled_offsety+$_mc[0]*$_delta_wcy );
}
$caption_start_x = pop @_x_caption;
$caption_start_y = pop @_y_caption ;

($_Wx[0],$_Wy[0]) = ($caption_start_x, $caption_start_y);  #############################################################

foreach(0..$#xcaption){

$xc = $xcaption[$_]-$relative_x*$_xmax_c-(1-$relative_x)*$_xmin_c;
$yc = $ycaption[$_]-$relative_y*$_ymax_c-(1-$relative_y)*$_ymin_c;

($xc, $yc) = ($_Mx[0]*$xc, $_My[0]*$yc );#

($xc, $yc)=($cosC*$xc-$sinC*$yc, $sinC*$xc+$cosC*$yc);

$xc = $xc+$caption_start_x;
$yc = $yc+$caption_start_y;

if($flag[$_] ==5){  #stores start position of caption in  a caption stack
# this will be used in a future call to the caption method
push @_x_caption, $xc;
push @_y_caption, $yc ;
push @_angle_caption, $_angle ;
$_lineto = $current_default ;
next;
}
if($flag[$_]==6){  #stores information for the node
# this will be used in a future call to the pull_node method
push @_x_stack, $xc ;
push @_y_stack, $yc ;
push @_angle_stack, $_angle ;
$_lineto = $current_default ;
next;
}
############################

if($xc < $_xmin ){$_xmin = $xc}
if($xc > $_xmax ){$_xmax = $xc}
if($yc < $_ymin ){$_ymin = $yc}
if($yc > $_ymax ){$_ymax = $yc}



push @_x, $xc;
push @_y, $yc;
push @_flag, $flag[$_];
}

return;

};




sub queue_style{
my ($self, %new_style) = @_;

@keys = keys %drawing_styles;  # duplicating the previous line in queue
foreach(@keys){
push @drawing_styles{$_}, $drawing_styles{$_}[-1];}

@keys2 = keys %new_style;  # updating last line added
foreach(@keys2){
pop @drawing_styles{$_};
push @drawing_styles{$_}, $new_style{$_};}  #replace with new value

}


sub make_image{

if(($_xmax-$_xmin)>($_ymax-$_ymin)){
($_xmin,$_xmax)= ($_xmin-$_border*($_xmax-$_xmin),$_xmax+$_border*($_xmax-$_xmin));
($_ymin,$_ymax)= ($_ymin-$_border*($_xmax-$_xmin),$_ymax+$_border*($_xmax-$_xmin));
$_pixels_x = $_pixels;
$_pixels_y = $_pixels *($_ymax-$_ymin)/($_xmax-$_xmin);
}
else{
($_ymin,$_ymax)= ($_ymin-$_border*($_ymax-$_ymin),$_ymax+$_border*($_ymax-$_ymin));
($_xmin,$_xmax)= ($_xmin-$_border*($_ymax-$_ymin),$_xmax+$_border*($_ymax-$_ymin));
$_pixels_y = $_pixels;
$_pixels_x = $_pixels *($_xmax-$_xmin)/($_ymax-$_ymin);
}


    my $graphRef = new WWPlot($_pixels_x, $_pixels_y);
	

	# select a  name for this graph based on the user, the psvn and the problem
	my $setName = $main::setNumber;
	# replace dots, commmas and @ signs in set and user names to keep latex and html happy
	# this should be abstracted and placed in PGalias.pm or PGcore.pm or perhaps PG.pm
	#FIXME
	$setName =~ s/Q/QQ/g;
	$setName =~ s/\./-Q-/g;
	my $studentLogin = $main::studentLogin;
	$studentLogin =~ s/Q/QQ/g;
	$studentLogin =~ s/\./-Q-/g;
	$studentLogin =~ s/\,/-Q-/g;
	$studentLogin =~ s/\@/-Q-/g;
	my $imageName = "$studentLogin-$main::problemSeed-set${setName}prob${main::probNum}";
	# $imageNum counts the number of graphs with this name which have been created since PGgraphmacros.pl was initiated.
	my $imageNum  = ++$main::images_created{$imageName};
	# this provides a unique name for the graph -- it does not include an extension.
	$graphRef->imageName("${imageName}image${imageNum}");	

        $graphRef->xmin($_xmin);
	$graphRef->xmax($_xmax) ;
	$graphRef->ymin($_ymin);
	$graphRef->ymax($_ymax) ;


sub make_rgb{
my ($x)= @_;
my $red = int($x/(256**2) -  0.5);
my $green =  int($x/256 -0.5)% 256 ;
my $blue = int($x % 256 );
return ($red,$green,$blue);
}

$i = 0;
update_styles();
sub update_styles{
$i++;
$Line_width = shift  $drawing_styles{L_w};
$line_width =shift  $drawing_styles{l_w};
$graphRef->new_color("line_color",make_rgb(shift $drawing_styles{l_c}));
$graphRef->new_color("LINE_color",make_rgb(shift $drawing_styles{L_c}));
$graphRef->new_color("Foreground_color".$i,make_rgb(shift $drawing_styles{F_c}));
$graphRef->new_color("Background_color",make_rgb(shift $drawing_styles{f_c}));

}

foreach (0..$#_x){

if ($_flag[$_] ==1){   #most common first - this is the default line style - L


$graphRef->lineTo($_x[$_],$_y[$_],'LINE_color',$Line_width );
next;
}

if ($_flag[$_] ==2){   #most common first - this is a secondary line style - l
$graphRef->lineTo($_x[$_],$_y[$_],'line_color',$line_width );
next;}

if ($_flag[$_] ==0){   #this requires no more
$graphRef->moveTo($_x[$_],$_y[$_]);
next;}

if ($_flag[$_] ==3){  #this is the default (foreground) fill - F
$FC = "Foreground_color".$i;
$graphRef->fillRegion([$_x[$_],$_y[$_],$FC]);
next;}


if ($_flag[$_] ==4){  #this is the secondary (background) fill - f
$graphRef->fillRegion([$_x[$_],$_y[$_],'Background_color']);
next;}
 
if ($_flag[$_] ==25){  #this will update the styles
update_styles();
next;}


}  
return $graphRef;
}

#########################################################

1;
